-- recreate dependant views
DROP VIEW IF EXISTS QUARTERLY_VIEW;
DROP VIEW IF EXISTS LAST7DAYS_VIEW;
DROP VIEW IF EXISTS WEEKLY_VIEW;
DROP VIEW IF EXISTS MONTHLY_VIEW;
DROP VIEW IF EXISTS LAST14DAYS_VIEW;
DROP VIEW IF EXISTS LAST30DAYS_VIEW;
DROP MATERIALIZED VIEW IF EXISTS LAST93DAYS_VIEW;
DROP MATERIALIZED VIEW IF EXISTS TEST_CASE_HEALTH_VIEW;
DROP VIEW IF EXISTS NIGHTLY_VIEW CASCADE;
DROP VIEW IF EXISTS LAST24HOURS_VIEW;

DROP VIEW IF EXISTS LAST_24_HOURS_VIEW;
CREATE VIEW LAST_24_HOURS_VIEW AS (
    SELECT row_number() OVER ()                                                AS ID,
       PROJECTS.NAME                                                           AS PROJECT,
       USERS.ID                                                                AS OWNER_ID,
       USERS.USERNAME                                                          AS OWNER_USERNAME,
       TEST_CONFIGS.ENV                                                        as ENV,
       case when (TEST_CONFIGS.PLATFORM IS NULL OR TEST_CONFIGS.PLATFORM = '') then 'N/A'
           else TEST_CONFIGS.PLATFORM end                                      AS PLATFORM,
       TEST_CONFIGS.PLATFORM_VERSION                                           AS PLATFORM_VERSION,
       TEST_CONFIGS.BROWSER                                                    AS BROWSER,
       TEST_CONFIGS.BROWSER_VERSION                                            AS BROWSER_VERSION,
       case
           when (TEST_CONFIGS.APP_VERSION IS NULL) then ''
           else TEST_CONFIGS.APP_VERSION end                                   AS APP_VERSION,
       TEST_CONFIGS.DEVICE                                                     AS DEVICE,
       TEST_CONFIGS.LOCALE                                                     AS LOCALE,
       JOBS.JOB_URL                                                            AS JOB_URL,
       JOBS.NAME                                                               AS JOB_NAME,
       TEST_SUITES.USER_ID                                                     AS JOB_OWNER_ID,
       TEST_SUITES.NAME                                                        AS TEST_SUITE_NAME,
       TEST_SUITES.FILE_NAME                                                   AS TEST_SUITE_FILE,
       TEST_RUNS.ID                                                            AS TEST_RUN_ID,
       TEST_RUNS.STATUS                                                        AS TEST_RUN_STATUS,
       TEST_RUNS.BUILD_NUMBER                                                  AS BUILD_NUMBER,
       '<a href="test-runs/' || TEST_RUNS.ID || '/tests/' || TESTS.ID || '" target="_blank">' || TESTS.NAME ||
       '</a>'                                                                  AS TEST_INFO_URL,
       TEST_RUNS.ELAPSED                                                       AS ELAPSED,
       TEST_RUNS.STARTED_AT                                                    AS STARTED_AT,
       TEST_RUNS.UPSTREAM_JOB_ID                                               AS UPSTREAM_JOB_ID,
       TEST_RUNS.UPSTREAM_JOB_BUILD_NUMBER                                     AS UPSTREAM_JOB_BUILD_NUMBER,
       TEST_RUNS.REVIEWED                                                      AS REVIEWED,
       UPSTREAM_JOBS.NAME                                                      AS UPSTREAM_JOB_NAME,
       UPSTREAM_JOBS.JOB_URL                                                   AS UPSTREAM_JOB_URL,
       PRIORITY_LABELS.VALUE                                                   AS PRIORITY,
       FEATURE_LABELS.VALUE                                                    AS FEATURE,
       TASK_ITEMS.JIRA_ID                                                      AS TASK,
       BUG_ITEMS.JIRA_ID                                                       AS BUG,
       BUG_ITEMS.DESCRIPTION                                                   AS BUG_SUBJECT,
       TESTS.NAME                                                              AS TEST_NAME,
       TESTS.MESSAGE                                                           AS MESSAGE,
       TESTS.MESSAGE_HASH_CODE                                                 AS MESSAGE_HASHCODE,
       TESTS.BLOCKER                                                           AS TEST_BLOCKER,
       TESTS.KNOWN_ISSUE                                                       AS TEST_KNOWN_ISSUE,
       TEST_CASES.TEST_METHOD                                                  AS TEST_METHOD_NAME,
       '<a href="dashboards/' || (select ID from dashboards where title = 'Stability') || '?testCaseId=' ||
       TEST_CASES.ID || '">' || TEST_CASES.TEST_METHOD ||
       '</a>'                                                                  AS STABILITY_URL,
       sum(case when TESTS.STATUS = 'PASSED' then 1 else 0 end)                AS PASSED,
       sum(case
               when TESTS.STATUS = 'FAILED' AND TESTS.KNOWN_ISSUE = FALSE then 1
               else 0 end)                                                     AS FAILED,
       sum(case
               when TESTS.STATUS = 'FAILED' AND TESTS.KNOWN_ISSUE = TRUE then 1
               else 0 end)                                                     AS KNOWN_ISSUE,
       sum(case when TESTS.STATUS = 'SKIPPED' then 1 else 0 end)               AS SKIPPED,
       sum(case when TESTS.STATUS = 'ABORTED' then 1 else 0 end)               AS ABORTED,
       sum(case when TESTS.STATUS = 'IN_PROGRESS' then 1 else 0 end)           AS IN_PROGRESS,
       count(TESTS.STATUS)                                                     AS TOTAL,
       sum(EXTRACT(epoch FROM (TESTS.FINISH_TIME - TESTS.START_TIME)))::bigint as TOTAL_SECONDS,
       avg(TESTS.FINISH_TIME - TESTS.START_TIME)                               as AVG_TIME
    FROM TESTS
         INNER JOIN TEST_RUNS ON TEST_RUNS.ID = TESTS.TEST_RUN_ID
         INNER JOIN TEST_CASES ON TESTS.TEST_CASE_ID = TEST_CASES.ID
         LEFT JOIN TEST_CONFIGS ON TEST_RUNS.CONFIG_ID = TEST_CONFIGS.ID
         INNER JOIN PROJECTS ON TEST_RUNS.PROJECT_ID = PROJECTS.ID
         LEFT JOIN JOBS JOBS ON TEST_RUNS.JOB_ID = JOBS.ID
         LEFT JOIN JOBS UPSTREAM_JOBS ON TEST_RUNS.UPSTREAM_JOB_ID = UPSTREAM_JOBS.ID
         INNER JOIN USERS ON TEST_CASES.PRIMARY_OWNER_ID = USERS.ID
         INNER JOIN TEST_SUITES ON TEST_RUNS.TEST_SUITE_ID = TEST_SUITES.ID
         LEFT JOIN TESTS_LABELS PRIORITY_TEST_LABELS ON TESTS.ID = PRIORITY_TEST_LABELS.TEST_ID AND
                                                        PRIORITY_TEST_LABELS.LABEL_ID IN
                                                        (SELECT ID FROM LABELS WHERE key = 'priority')
         LEFT JOIN LABELS PRIORITY_LABELS
                   ON (PRIORITY_TEST_LABELS.LABEL_ID = PRIORITY_LABELS.ID AND PRIORITY_LABELS.KEY = 'priority')
         LEFT JOIN TESTS_LABELS FEATURE_TEST_LABELS ON TESTS.ID = FEATURE_TEST_LABELS.TEST_ID AND
                                                       FEATURE_TEST_LABELS.LABEL_ID IN (SELECT ID FROM LABELS WHERE key = 'feature')
         LEFT JOIN LABELS FEATURE_LABELS ON FEATURE_TEST_LABELS.LABEL_ID = FEATURE_LABELS.ID AND FEATURE_LABELS.KEY = 'feature'
         LEFT JOIN TEST_WORK_ITEMS TASK_WORK_ITEMS ON TESTS.ID = TASK_WORK_ITEMS.TEST_ID AND
                                                      TASK_WORK_ITEMS.WORK_ITEM_ID IN
                                                      (SELECT ID FROM WORK_ITEMS WHERE type = 'TASK')
         LEFT JOIN WORK_ITEMS TASK_ITEMS ON (TASK_WORK_ITEMS.WORK_ITEM_ID = TASK_ITEMS.ID AND TASK_ITEMS.TYPE = 'TASK')
         LEFT JOIN TEST_WORK_ITEMS BUG_WORK_ITEMS ON TESTS.ID = BUG_WORK_ITEMS.TEST_ID AND
                                                     BUG_WORK_ITEMS.WORK_ITEM_ID IN
                                                     (SELECT ID FROM WORK_ITEMS WHERE type = 'BUG')
         LEFT JOIN WORK_ITEMS BUG_ITEMS ON (BUG_WORK_ITEMS.WORK_ITEM_ID = BUG_ITEMS.ID AND BUG_ITEMS.TYPE = 'BUG')
    WHERE TEST_RUNS.STARTED_AT >= (current_date - interval '1 day')
    GROUP BY PROJECTS.NAME, TEST_RUNS.ID, USERS.ID, TEST_CONFIGS.ENV, TEST_CONFIGS.PLATFORM, TEST_CONFIGS.PLATFORM_VERSION,
         TEST_CONFIGS.BROWSER, TEST_CONFIGS.BROWSER_VERSION,
         TEST_CONFIGS.DEVICE, TEST_CONFIGS.LOCALE, TEST_CONFIGS.APP_VERSION,
         TESTS.ID, JOBS.JOB_URL, JOBS.NAME,
         UPSTREAM_JOBS.NAME, UPSTREAM_JOBS.JOB_URL, TEST_SUITES.NAME, TEST_SUITES.FILE_NAME, TEST_SUITES.USER_ID,
         PRIORITY_LABELS.VALUE, FEATURE_LABELS.VALUE,
         TASK_ITEMS.JIRA_ID, BUG_ITEMS.JIRA_ID, BUG_ITEMS.DESCRIPTION,
         TESTS.NAME, TESTS.MESSAGE, TESTS.MESSAGE_HASH_CODE, TESTS.BLOCKER, TESTS.KNOWN_ISSUE, TEST_CASES.ID
    );

CREATE VIEW NIGHTLY_VIEW AS (
    SELECT * FROM LAST_24_HOURS_VIEW WHERE STARTED_AT >= current_date
);


DROP MATERIALIZED VIEW IF EXISTS LAST32DAYS_VIEW;
CREATE MATERIALIZED VIEW LAST_32_DAYS_VIEW AS (
    SELECT row_number() OVER ()                                                    AS ID,
       PROJECTS.NAME                                                           AS PROJECT,
       USERS.ID                                                                AS OWNER_ID,
       USERS.USERNAME                                                          AS OWNER_USERNAME,
       TEST_CONFIGS.ENV                                                        as ENV,
       case
           when (TEST_CONFIGS.PLATFORM IS NULL OR TEST_CONFIGS.PLATFORM = '') then 'N/A'
           else TEST_CONFIGS.PLATFORM end                                      AS PLATFORM,
       TEST_CONFIGS.PLATFORM_VERSION                                           AS PLATFORM_VERSION,
       TEST_CONFIGS.BROWSER                                                    AS BROWSER,
       TEST_CONFIGS.BROWSER_VERSION                                            AS BROWSER_VERSION,
       case
           when (TEST_CONFIGS.APP_VERSION IS NULL) then ''
           else TEST_CONFIGS.APP_VERSION end                                   AS APP_VERSION,
       TEST_CONFIGS.DEVICE                                                     AS DEVICE,
       TEST_CONFIGS.LOCALE                                                     AS LOCALE,
       JOBS.JOB_URL                                                            AS JOB_URL,
       JOBS.NAME                                                               AS JOB_NAME,
       TEST_SUITES.USER_ID                                                     AS JOB_OWNER_ID,
       TEST_SUITES.NAME                                                        AS TEST_SUITE_NAME,
       TEST_SUITES.FILE_NAME                                                   AS TEST_SUITE_FILE,
       TEST_RUNS.ID                                                            AS TEST_RUN_ID,
       TEST_RUNS.STATUS                                                        AS TEST_RUN_STATUS,
       TEST_RUNS.BUILD_NUMBER                                                  AS BUILD_NUMBER,
       '<a href="test-runs/' || TEST_RUNS.ID || '/tests/' || TESTS.ID || '" target="_blank">' || TESTS.NAME ||
       '</a>'                                                                  AS TEST_INFO_URL,
       TEST_RUNS.ELAPSED                                                       AS ELAPSED,
       TEST_RUNS.STARTED_AT                                                    AS STARTED_AT,
       TEST_RUNS.UPSTREAM_JOB_ID                                               AS UPSTREAM_JOB_ID,
       TEST_RUNS.UPSTREAM_JOB_BUILD_NUMBER                                     AS UPSTREAM_JOB_BUILD_NUMBER,
       TEST_RUNS.REVIEWED                                                      AS REVIEWED,
       UPSTREAM_JOBS.NAME                                                      AS UPSTREAM_JOB_NAME,
       UPSTREAM_JOBS.JOB_URL                                                   AS UPSTREAM_JOB_URL,
       PRIORITY_LABELS.VALUE                                                     AS PRIORITY,
       FEATURE_LABELS.VALUE                                                      AS FEATURE,
       TASK_ITEMS.JIRA_ID                                                      AS TASK,
       BUG_ITEMS.JIRA_ID                                                       AS BUG,
       BUG_ITEMS.DESCRIPTION                                                   AS BUG_SUBJECT,
       TESTS.NAME                                                              AS TEST_NAME,
       TESTS.MESSAGE                                                           AS MESSAGE,
       TESTS.MESSAGE_HASH_CODE                                                 AS MESSAGE_HASHCODE,
       TESTS.BLOCKER                                                           AS TEST_BLOCKER,
       TESTS.KNOWN_ISSUE                                                       AS TEST_KNOWN_ISSUE,
       TEST_CASES.TEST_METHOD                                                  AS TEST_METHOD_NAME,
       '<a href="dashboards/' || (select ID from dashboards where title = 'Stability') || '?testCaseId=' ||
       TEST_CASES.ID || '">' || TEST_CASES.TEST_METHOD ||
       '</a>'                                                                  AS STABILITY_URL,
       sum(case when TESTS.STATUS = 'PASSED' then 1 else 0 end)                AS PASSED,
       sum(case
               when TESTS.STATUS = 'FAILED' AND TESTS.KNOWN_ISSUE = FALSE then 1
               else 0 end)                                                     AS FAILED,
       sum(case
               when TESTS.STATUS = 'FAILED' AND TESTS.KNOWN_ISSUE = TRUE then 1
               else 0 end)                                                     AS KNOWN_ISSUE,
       sum(case when TESTS.STATUS = 'SKIPPED' then 1 else 0 end)               AS SKIPPED,
       sum(case when TESTS.STATUS = 'ABORTED' then 1 else 0 end)               AS ABORTED,
       sum(case when TESTS.STATUS = 'IN_PROGRESS' then 1 else 0 end)           AS IN_PROGRESS,
       count(TESTS.STATUS)                                                     AS TOTAL,
       sum(EXTRACT(epoch FROM (TESTS.FINISH_TIME - TESTS.START_TIME)))::bigint as TOTAL_SECONDS,
       avg(TESTS.FINISH_TIME - TESTS.START_TIME)                               as AVG_TIME
    FROM TESTS
         INNER JOIN TEST_RUNS ON TEST_RUNS.ID = TESTS.TEST_RUN_ID
         INNER JOIN TEST_CASES ON TESTS.TEST_CASE_ID = TEST_CASES.ID
         LEFT JOIN TEST_CONFIGS ON TEST_RUNS.CONFIG_ID = TEST_CONFIGS.ID
         INNER JOIN PROJECTS ON TEST_RUNS.PROJECT_ID = PROJECTS.ID
         LEFT JOIN JOBS JOBS ON TEST_RUNS.JOB_ID = JOBS.ID
         LEFT JOIN JOBS UPSTREAM_JOBS ON TEST_RUNS.UPSTREAM_JOB_ID = UPSTREAM_JOBS.ID
         INNER JOIN USERS ON TEST_CASES.PRIMARY_OWNER_ID = USERS.ID
         INNER JOIN TEST_SUITES ON TEST_RUNS.TEST_SUITE_ID = TEST_SUITES.ID
         LEFT JOIN TESTS_LABELS PRIORITY_TEST_LABELS ON TESTS.ID = PRIORITY_TEST_LABELS.TEST_ID AND
                                                        PRIORITY_TEST_LABELS.LABEL_ID IN
                                                        (SELECT ID FROM LABELS WHERE key = 'priority')
         LEFT JOIN LABELS PRIORITY_LABELS
                   ON (PRIORITY_TEST_LABELS.LABEL_ID = PRIORITY_LABELS.ID AND PRIORITY_LABELS.KEY = 'priority')
         LEFT JOIN TESTS_LABELS FEATURE_TEST_LABELS ON TESTS.ID = FEATURE_TEST_LABELS.TEST_ID AND
                                                       FEATURE_TEST_LABELS.LABEL_ID IN (SELECT ID FROM LABELS WHERE key = 'feature')
         LEFT JOIN LABELS FEATURE_LABELS ON FEATURE_TEST_LABELS.LABEL_ID = FEATURE_LABELS.ID AND FEATURE_LABELS.KEY = 'feature'
         LEFT JOIN TEST_WORK_ITEMS TASK_WORK_ITEMS ON TESTS.ID = TASK_WORK_ITEMS.TEST_ID AND
                                                      TASK_WORK_ITEMS.WORK_ITEM_ID IN
                                                      (SELECT ID FROM WORK_ITEMS WHERE type = 'TASK')
         LEFT JOIN WORK_ITEMS TASK_ITEMS ON (TASK_WORK_ITEMS.WORK_ITEM_ID = TASK_ITEMS.ID AND TASK_ITEMS.TYPE = 'TASK')
         LEFT JOIN TEST_WORK_ITEMS BUG_WORK_ITEMS ON TESTS.ID = BUG_WORK_ITEMS.TEST_ID AND
                                                     BUG_WORK_ITEMS.WORK_ITEM_ID IN
                                                     (SELECT ID FROM WORK_ITEMS WHERE type = 'BUG')
         LEFT JOIN WORK_ITEMS BUG_ITEMS ON (BUG_WORK_ITEMS.WORK_ITEM_ID = BUG_ITEMS.ID AND BUG_ITEMS.TYPE = 'BUG')
    WHERE TEST_RUNS.STARTED_AT > current_date - 32 AND TEST_RUNS.STARTED_AT < current_date
    GROUP BY PROJECTS.NAME, TEST_RUNS.ID, TESTS.ID, USERS.ID, TEST_CONFIGS.ENV, TEST_CONFIGS.PLATFORM,
         TEST_CONFIGS.PLATFORM_VERSION, TEST_CONFIGS.BROWSER, TEST_CONFIGS.BROWSER_VERSION,
         TEST_CONFIGS.DEVICE, TEST_CONFIGS.LOCALE, TEST_CONFIGS.APP_VERSION,
         JOBS.JOB_URL, JOBS.NAME,
         UPSTREAM_JOBS.NAME, UPSTREAM_JOBS.JOB_URL, TEST_SUITES.NAME, TEST_SUITES.FILE_NAME, TEST_SUITES.USER_ID,
         PRIORITY_LABELS.VALUE, FEATURE_LABELS.VALUE,
         TASK_ITEMS.JIRA_ID, BUG_ITEMS.JIRA_ID, BUG_ITEMS.DESCRIPTION,
         TESTS.NAME, TESTS.MESSAGE, TESTS.MESSAGE_HASH_CODE, TESTS.BLOCKER, TESTS.KNOWN_ISSUE, TEST_CASES.ID
    );

DROP INDEX IF EXISTS LAST32DAYS_VIEW_INDEX;
CREATE UNIQUE INDEX LAST_32_DAYS_VIEW_INDEX ON LAST_32_DAYS_VIEW (ID);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_PROJECT_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_PROJECT_INDEX ON LAST_32_DAYS_VIEW (PROJECT);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_OWNER_ID_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_OWNER_ID_INDEX ON LAST_32_DAYS_VIEW (OWNER_ID);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_OWNER_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_OWNER_INDEX ON LAST_32_DAYS_VIEW (OWNER_USERNAME);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_PLATFORM_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_PLATFORM_INDEX ON LAST_32_DAYS_VIEW (PLATFORM);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_PLATFORM_VERSION_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_PLATFORM_VERSION_INDEX ON LAST_32_DAYS_VIEW (PLATFORM_VERSION);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_BROWSER_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_BROWSER_INDEX ON LAST_32_DAYS_VIEW (BROWSER);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_BROWSER_VERSION_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_BROWSER_VERSION_INDEX ON LAST_32_DAYS_VIEW (BROWSER_VERSION);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_APP_VERSION_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_APP_VERSION_INDEX ON LAST_32_DAYS_VIEW (APP_VERSION);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_DEVICE_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_DEVICE_INDEX ON LAST_32_DAYS_VIEW (DEVICE);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_LOCALE_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_LOCALE_INDEX ON LAST_32_DAYS_VIEW (LOCALE);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_JOB_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_JOB_INDEX ON LAST_32_DAYS_VIEW (JOB_URL);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_JOB_NAME_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_JOB_NAME_INDEX ON LAST_32_DAYS_VIEW (JOB_NAME);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_JOB_OWNER_ID_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_JOB_OWNER_ID_INDEX ON LAST_32_DAYS_VIEW (JOB_OWNER_ID);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_TEST_SUITE_NAME_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_TEST_SUITE_NAME_INDEX ON LAST_32_DAYS_VIEW (TEST_SUITE_NAME);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_TEST_SUITE_FILE_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_TEST_SUITE_FILE_INDEX ON LAST_32_DAYS_VIEW (TEST_SUITE_FILE);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_ENV_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_ENV_INDEX ON LAST_32_DAYS_VIEW (ENV);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_TEST_RUN_ID_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_TEST_RUN_ID_INDEX ON LAST_32_DAYS_VIEW (TEST_RUN_ID);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_TEST_RUN_STATUS_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_TEST_RUN_STATUS_INDEX ON LAST_32_DAYS_VIEW (TEST_RUN_STATUS);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_BUILD_NUMBER_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_BUILD_NUMBER_INDEX ON LAST_32_DAYS_VIEW (BUILD_NUMBER);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_TEST_INFO_URL_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_TEST_INFO_URL_INDEX ON LAST_32_DAYS_VIEW (TEST_INFO_URL);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_ELAPSED_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_ELAPSED_INDEX ON LAST_32_DAYS_VIEW (ELAPSED);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_STARTED_AT_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_STARTED_AT_INDEX ON LAST_32_DAYS_VIEW (STARTED_AT);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_UPSTREAM_JOB_ID_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_UPSTREAM_JOB_ID_INDEX ON LAST_32_DAYS_VIEW (UPSTREAM_JOB_ID);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_UPSTREAM_JOB_BUILD_NUMBER_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_UPSTREAM_JOB_BUILD_NUMBER_INDEX ON LAST_32_DAYS_VIEW (UPSTREAM_JOB_BUILD_NUMBER);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_REVIEWED_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_REVIEWED_INDEX ON LAST_32_DAYS_VIEW (REVIEWED);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_UPSTREAM_JOB_NAME_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_UPSTREAM_JOB_NAME_INDEX ON LAST_32_DAYS_VIEW (UPSTREAM_JOB_NAME);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_UPSTREAM_JOB_URL_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_UPSTREAM_JOB_URL_INDEX ON LAST_32_DAYS_VIEW (UPSTREAM_JOB_URL);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_PRIORITY_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_PRIORITY_INDEX ON LAST_32_DAYS_VIEW (PRIORITY);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_FEATURE_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_FEATURE_INDEX ON LAST_32_DAYS_VIEW (FEATURE);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_TASK_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_TASK_INDEX ON LAST_32_DAYS_VIEW (TASK);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_BUG_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_BUG_INDEX ON LAST_32_DAYS_VIEW (BUG);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_BUG_SUBJECT_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_BUG_SUBJECT_INDEX ON LAST_32_DAYS_VIEW (BUG_SUBJECT);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_TEST_NAME_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_TEST_NAME_INDEX ON LAST_32_DAYS_VIEW (TEST_NAME);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_MESSAGE_HASHCODE_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_MESSAGE_HASHCODE_INDEX ON LAST_32_DAYS_VIEW (MESSAGE_HASHCODE);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_TEST_BLOCKER_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_TEST_BLOCKER_INDEX ON LAST_32_DAYS_VIEW (TEST_BLOCKER);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_TEST_KNOWN_ISSUE_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_TEST_KNOWN_ISSUE_INDEX ON LAST_32_DAYS_VIEW (TEST_KNOWN_ISSUE);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_TEST_CASE_NAME_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_TEST_CASE_NAME_INDEX ON LAST_32_DAYS_VIEW (TEST_METHOD_NAME);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_STABILITY_URL_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_STABILITY_URL_INDEX ON LAST_32_DAYS_VIEW (STABILITY_URL);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_PASSED_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_PASSED_INDEX ON LAST_32_DAYS_VIEW (PASSED);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_FAILED_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_FAILED_INDEX ON LAST_32_DAYS_VIEW (FAILED);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_KNOWN_ISSUE_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_KNOWN_ISSUE_INDEX ON LAST_32_DAYS_VIEW (KNOWN_ISSUE);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_SKIPPED_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_SKIPPED_INDEX ON LAST_32_DAYS_VIEW (SKIPPED);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_ABORTED_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_ABORTED_INDEX ON LAST_32_DAYS_VIEW (ABORTED);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_IN_PROGRESS_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_IN_PROGRESS_INDEX ON LAST_32_DAYS_VIEW (IN_PROGRESS);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_TOTAL_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_TOTAL_INDEX ON LAST_32_DAYS_VIEW (TOTAL);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_TOTAL_SECONDS_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_TOTAL_SECONDS_INDEX ON LAST_32_DAYS_VIEW (TOTAL_SECONDS);

DROP INDEX IF EXISTS LAST32DAYS_VIEW_AVG_TIME_INDEX;
CREATE INDEX LAST_32_DAYS_VIEW_AVG_TIME_INDEX ON LAST_32_DAYS_VIEW (AVG_TIME);


CREATE VIEW LAST_30_DAYS_VIEW AS (
    SELECT * FROM LAST_32_DAYS_VIEW WHERE STARTED_AT >= (current_date - interval '30 day')
    UNION ALL
    SELECT * FROM NIGHTLY_VIEW
);


CREATE VIEW LAST_14_DAYS_VIEW AS (
    SELECT * FROM LAST_30_DAYS_VIEW WHERE STARTED_AT >= (current_date - interval '14 day')
);


CREATE VIEW MONTHLY_VIEW AS (
    SELECT * FROM LAST_30_DAYS_VIEW WHERE STARTED_AT >= date_trunc('month', current_date)
);


CREATE VIEW WEEKLY_VIEW AS (
    SELECT * FROM LAST_30_DAYS_VIEW WHERE STARTED_AT >= date_trunc('week', current_date) - interval '2 day'
);

CREATE VIEW LAST_7_DAYS_VIEW AS (
    SELECT * FROM LAST_30_DAYS_VIEW WHERE STARTED_AT >= current_date - interval '7 day'
);


DROP MATERIALIZED VIEW IF EXISTS LAST_93_DAYS_VIEW;
CREATE MATERIALIZED VIEW LAST_93_DAYS_VIEW AS (
    SELECT row_number() OVER ()                                                    AS ID,
       PROJECTS.NAME                                                           AS PROJECT,
       USERS.ID                                                                AS OWNER_ID,
       USERS.USERNAME                                                          AS OWNER_USERNAME,
       TEST_CONFIGS.ENV                                                        as ENV,
       case
           when (TEST_CONFIGS.PLATFORM IS NULL OR TEST_CONFIGS.PLATFORM = '') then 'N/A'
           else TEST_CONFIGS.PLATFORM end                                      AS PLATFORM,
       TEST_CONFIGS.PLATFORM_VERSION                                           AS PLATFORM_VERSION,
       TEST_CONFIGS.BROWSER                                                    AS BROWSER,
       TEST_CONFIGS.BROWSER_VERSION                                            AS BROWSER_VERSION,
       case
           when (TEST_CONFIGS.APP_VERSION IS NULL) then ''
           else TEST_CONFIGS.APP_VERSION end                                   AS APP_VERSION,
       TEST_CONFIGS.DEVICE                                                     AS DEVICE,
       TEST_CONFIGS.LOCALE                                                     AS LOCALE,
       JOBS.JOB_URL                                                            AS JOB_URL,
       JOBS.NAME                                                               AS JOB_NAME,
       TEST_SUITES.USER_ID                                                     AS JOB_OWNER_ID,
       TEST_SUITES.NAME                                                        AS TEST_SUITE_NAME,
       TEST_SUITES.FILE_NAME                                                   AS TEST_SUITE_FILE,
       TEST_RUNS.ID                                                            AS TEST_RUN_ID,
       TEST_RUNS.STATUS                                                        AS TEST_RUN_STATUS,
       TEST_RUNS.BUILD_NUMBER                                                  AS BUILD_NUMBER,
       '<a href="test-runs/' || TEST_RUNS.ID || '/tests/' || TESTS.ID || '" target="_blank">' || TESTS.NAME ||
       '</a>'                                                                  AS TEST_INFO_URL,
       TEST_RUNS.ELAPSED                                                       AS ELAPSED,
       TEST_RUNS.STARTED_AT                                                    AS STARTED_AT,
       TEST_RUNS.UPSTREAM_JOB_ID                                               AS UPSTREAM_JOB_ID,
       TEST_RUNS.UPSTREAM_JOB_BUILD_NUMBER                                     AS UPSTREAM_JOB_BUILD_NUMBER,
       TEST_RUNS.REVIEWED                                                      AS REVIEWED,
       UPSTREAM_JOBS.NAME                                                      AS UPSTREAM_JOB_NAME,
       UPSTREAM_JOBS.JOB_URL                                                   AS UPSTREAM_JOB_URL,
       PRIORITY_LABELS.VALUE                                                     AS PRIORITY,
       FEATURE_LABELS.VALUE                                                      AS FEATURE,
       TASK_ITEMS.JIRA_ID                                                      AS TASK,
       BUG_ITEMS.JIRA_ID                                                       AS BUG,
       BUG_ITEMS.DESCRIPTION                                                   AS BUG_SUBJECT,
       TESTS.NAME                                                              AS TEST_NAME,
       TESTS.MESSAGE                                                           AS MESSAGE,
       TESTS.MESSAGE_HASH_CODE                                                 AS MESSAGE_HASHCODE,
       TESTS.BLOCKER                                                           AS TEST_BLOCKER,
       TESTS.KNOWN_ISSUE                                                       AS TEST_KNOWN_ISSUE,
       TEST_CASES.TEST_METHOD                                                  AS TEST_METHOD_NAME,
       '<a href="dashboards/' || (select ID from dashboards where title = 'Stability') || '?testCaseId=' ||
       TEST_CASES.ID || '">' || TEST_CASES.TEST_METHOD ||
       '</a>'                                                                  AS STABILITY_URL,
       sum(case when TESTS.STATUS = 'PASSED' then 1 else 0 end)                AS PASSED,
       sum(case
               when TESTS.STATUS = 'FAILED' AND TESTS.KNOWN_ISSUE = FALSE then 1
               else 0 end)                                                     AS FAILED,
       sum(case
               when TESTS.STATUS = 'FAILED' AND TESTS.KNOWN_ISSUE = TRUE then 1
               else 0 end)                                                     AS KNOWN_ISSUE,
       sum(case when TESTS.STATUS = 'SKIPPED' then 1 else 0 end)               AS SKIPPED,
       sum(case when TESTS.STATUS = 'ABORTED' then 1 else 0 end)               AS ABORTED,
       sum(case when TESTS.STATUS = 'IN_PROGRESS' then 1 else 0 end)           AS IN_PROGRESS,
       count(TESTS.STATUS)                                                     AS TOTAL,
       sum(EXTRACT(epoch FROM (TESTS.FINISH_TIME - TESTS.START_TIME)))::bigint as TOTAL_SECONDS,
       avg(TESTS.FINISH_TIME - TESTS.START_TIME)                               as AVG_TIME
    FROM TESTS
         INNER JOIN TEST_RUNS ON TEST_RUNS.ID = TESTS.TEST_RUN_ID
         INNER JOIN TEST_CASES ON TESTS.TEST_CASE_ID = TEST_CASES.ID
         LEFT JOIN TEST_CONFIGS ON TEST_RUNS.CONFIG_ID = TEST_CONFIGS.ID
         INNER JOIN PROJECTS ON TEST_RUNS.PROJECT_ID = PROJECTS.ID
         LEFT JOIN JOBS JOBS ON TEST_RUNS.JOB_ID = JOBS.ID
         LEFT JOIN JOBS UPSTREAM_JOBS ON TEST_RUNS.UPSTREAM_JOB_ID = UPSTREAM_JOBS.ID
         INNER JOIN USERS ON TEST_CASES.PRIMARY_OWNER_ID = USERS.ID
         INNER JOIN TEST_SUITES ON TEST_RUNS.TEST_SUITE_ID = TEST_SUITES.ID
         LEFT JOIN TESTS_LABELS PRIORITY_TEST_LABELS ON TESTS.ID = PRIORITY_TEST_LABELS.TEST_ID AND
                                                        PRIORITY_TEST_LABELS.LABEL_ID IN
                                                        (SELECT ID FROM LABELS WHERE key = 'priority')
         LEFT JOIN LABELS PRIORITY_LABELS
                   ON (PRIORITY_TEST_LABELS.LABEL_ID = PRIORITY_LABELS.ID AND PRIORITY_LABELS.KEY = 'priority')
         LEFT JOIN TESTS_LABELS FEATURE_TEST_LABELS ON TESTS.ID = FEATURE_TEST_LABELS.TEST_ID AND
                                                       FEATURE_TEST_LABELS.LABEL_ID IN (SELECT ID FROM LABELS WHERE key = 'feature')
         LEFT JOIN LABELS FEATURE_LABELS ON FEATURE_TEST_LABELS.LABEL_ID = FEATURE_LABELS.ID AND FEATURE_LABELS.KEY = 'feature'
         LEFT JOIN TEST_WORK_ITEMS TASK_WORK_ITEMS ON TESTS.ID = TASK_WORK_ITEMS.TEST_ID AND
                                                      TASK_WORK_ITEMS.WORK_ITEM_ID IN
                                                      (SELECT ID FROM WORK_ITEMS WHERE type = 'TASK')
         LEFT JOIN WORK_ITEMS TASK_ITEMS ON (TASK_WORK_ITEMS.WORK_ITEM_ID = TASK_ITEMS.ID AND TASK_ITEMS.TYPE = 'TASK')
         LEFT JOIN TEST_WORK_ITEMS BUG_WORK_ITEMS ON TESTS.ID = BUG_WORK_ITEMS.TEST_ID AND
                                                     BUG_WORK_ITEMS.WORK_ITEM_ID IN
                                                     (SELECT ID FROM WORK_ITEMS WHERE type = 'BUG')
         LEFT JOIN WORK_ITEMS BUG_ITEMS ON (BUG_WORK_ITEMS.WORK_ITEM_ID = BUG_ITEMS.ID AND BUG_ITEMS.TYPE = 'BUG')
    WHERE TEST_RUNS.STARTED_AT > current_date - 93 AND TEST_RUNS.STARTED_AT < current_date
    GROUP BY PROJECTS.NAME, TEST_RUNS.ID, TESTS.ID, USERS.ID, TEST_CONFIGS.ENV, TEST_CONFIGS.PLATFORM,
         TEST_CONFIGS.PLATFORM_VERSION, TEST_CONFIGS.BROWSER, TEST_CONFIGS.BROWSER_VERSION,
         TEST_CONFIGS.DEVICE, TEST_CONFIGS.LOCALE, TEST_CONFIGS.APP_VERSION,
         JOBS.JOB_URL, JOBS.NAME,
         UPSTREAM_JOBS.NAME, UPSTREAM_JOBS.JOB_URL, TEST_SUITES.NAME, TEST_SUITES.FILE_NAME, TEST_SUITES.USER_ID,
         PRIORITY_LABELS.VALUE, FEATURE_LABELS.VALUE,
         TASK_ITEMS.JIRA_ID, BUG_ITEMS.JIRA_ID, BUG_ITEMS.DESCRIPTION,
         TESTS.NAME, TESTS.MESSAGE, TESTS.MESSAGE_HASH_CODE, TESTS.BLOCKER, TESTS.KNOWN_ISSUE, TEST_CASES.ID
    );

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_INDEX;
CREATE UNIQUE INDEX LAST_93_DAYS_VIEW_INDEX ON LAST_93_DAYS_VIEW (ID);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_PROJECT_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_PROJECT_INDEX ON LAST_93_DAYS_VIEW (PROJECT);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_OWNER_ID_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_OWNER_ID_INDEX ON LAST_93_DAYS_VIEW (OWNER_ID);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_OWNER_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_OWNER_INDEX ON LAST_93_DAYS_VIEW (OWNER_USERNAME);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_PLATFORM_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_PLATFORM_INDEX ON LAST_93_DAYS_VIEW (PLATFORM);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_PLATFORM_VERSION_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_PLATFORM_VERSION_INDEX ON LAST_93_DAYS_VIEW (PLATFORM_VERSION);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_BROWSER_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_BROWSER_INDEX ON LAST_93_DAYS_VIEW (BROWSER);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_BROWSER_VERSION_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_BROWSER_VERSION_INDEX ON LAST_93_DAYS_VIEW (BROWSER_VERSION);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_APP_VERSION_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_APP_VERSION_INDEX ON LAST_93_DAYS_VIEW (APP_VERSION);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_DEVICE_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_DEVICE_INDEX ON LAST_93_DAYS_VIEW (DEVICE);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_LOCALE_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_LOCALE_INDEX ON LAST_93_DAYS_VIEW (LOCALE);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_JOB_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_JOB_INDEX ON LAST_93_DAYS_VIEW (JOB_URL);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_JOB_NAME_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_JOB_NAME_INDEX ON LAST_93_DAYS_VIEW (JOB_NAME);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_JOB_OWNER_ID_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_JOB_OWNER_ID_INDEX ON LAST_93_DAYS_VIEW (JOB_OWNER_ID);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_TEST_SUITE_NAME_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_TEST_SUITE_NAME_INDEX ON LAST_93_DAYS_VIEW (TEST_SUITE_NAME);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_TEST_SUITE_FILE_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_TEST_SUITE_FILE_INDEX ON LAST_93_DAYS_VIEW (TEST_SUITE_FILE);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_ENV_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_ENV_INDEX ON LAST_93_DAYS_VIEW (ENV);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_TEST_RUN_ID_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_TEST_RUN_ID_INDEX ON LAST_93_DAYS_VIEW (TEST_RUN_ID);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_TEST_RUN_STATUS_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_TEST_RUN_STATUS_INDEX ON LAST_93_DAYS_VIEW (TEST_RUN_STATUS);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_BUILD_NUMBER_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_BUILD_NUMBER_INDEX ON LAST_93_DAYS_VIEW (BUILD_NUMBER);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_TEST_INFO_URL_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_TEST_INFO_URL_INDEX ON LAST_93_DAYS_VIEW (TEST_INFO_URL);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_ELAPSED_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_ELAPSED_INDEX ON LAST_93_DAYS_VIEW (ELAPSED);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_STARTED_AT_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_STARTED_AT_INDEX ON LAST_93_DAYS_VIEW (STARTED_AT);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_UPSTREAM_JOB_ID_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_UPSTREAM_JOB_ID_INDEX ON LAST_93_DAYS_VIEW (UPSTREAM_JOB_ID);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_UPSTREAM_JOB_BUILD_NUMBER_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_UPSTREAM_JOB_BUILD_NUMBER_INDEX ON LAST_93_DAYS_VIEW (UPSTREAM_JOB_BUILD_NUMBER);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_REVIEWED_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_REVIEWED_INDEX ON LAST_93_DAYS_VIEW (REVIEWED);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_UPSTREAM_JOB_NAME_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_UPSTREAM_JOB_NAME_INDEX ON LAST_93_DAYS_VIEW (UPSTREAM_JOB_NAME);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_UPSTREAM_JOB_URL_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_UPSTREAM_JOB_URL_INDEX ON LAST_93_DAYS_VIEW (UPSTREAM_JOB_URL);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_PRIORITY_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_PRIORITY_INDEX ON LAST_93_DAYS_VIEW (PRIORITY);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_FEATURE_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_FEATURE_INDEX ON LAST_93_DAYS_VIEW (FEATURE);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_TASK_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_TASK_INDEX ON LAST_93_DAYS_VIEW (TASK);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_BUG_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_BUG_INDEX ON LAST_93_DAYS_VIEW (BUG);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_BUG_SUBJECT_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_BUG_SUBJECT_INDEX ON LAST_93_DAYS_VIEW (BUG_SUBJECT);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_TEST_NAME_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_TEST_NAME_INDEX ON LAST_93_DAYS_VIEW (TEST_NAME);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_MESSAGE_HASHCODE_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_MESSAGE_HASHCODE_INDEX ON LAST_93_DAYS_VIEW (MESSAGE_HASHCODE);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_TEST_BLOCKER_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_TEST_BLOCKER_INDEX ON LAST_93_DAYS_VIEW (TEST_BLOCKER);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_TEST_KNOWN_ISSUE_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_TEST_KNOWN_ISSUE_INDEX ON LAST_93_DAYS_VIEW (TEST_KNOWN_ISSUE);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_TEST_CASE_NAME_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_TEST_CASE_NAME_INDEX ON LAST_93_DAYS_VIEW (TEST_METHOD_NAME);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_STABILITY_URL_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_STABILITY_URL_INDEX ON LAST_93_DAYS_VIEW (STABILITY_URL);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_PASSED_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_PASSED_INDEX ON LAST_93_DAYS_VIEW (PASSED);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_FAILED_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_FAILED_INDEX ON LAST_93_DAYS_VIEW (FAILED);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_KNOWN_ISSUE_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_KNOWN_ISSUE_INDEX ON LAST_93_DAYS_VIEW (KNOWN_ISSUE);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_SKIPPED_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_SKIPPED_INDEX ON LAST_93_DAYS_VIEW (SKIPPED);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_ABORTED_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_ABORTED_INDEX ON LAST_93_DAYS_VIEW (ABORTED);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_IN_PROGRESS_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_IN_PROGRESS_INDEX ON LAST_93_DAYS_VIEW (IN_PROGRESS);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_TOTAL_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_TOTAL_INDEX ON LAST_93_DAYS_VIEW (TOTAL);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_TOTAL_SECONDS_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_TOTAL_SECONDS_INDEX ON LAST_93_DAYS_VIEW (TOTAL_SECONDS);

DROP INDEX IF EXISTS LAST_93_DAYS_VIEW_AVG_TIME_INDEX;
CREATE INDEX LAST_93_DAYS_VIEW_AVG_TIME_INDEX ON LAST_93_DAYS_VIEW (AVG_TIME);


CREATE VIEW QUARTERLY_VIEW AS (
    SELECT * FROM LAST_93_DAYS_VIEW WHERE STARTED_AT >= date_trunc('quarter', current_date)
    UNION ALL
    SELECT * FROM NIGHTLY_VIEW
);




DROP MATERIALIZED VIEW IF EXISTS TOTAL_VIEW;
CREATE MATERIALIZED VIEW TOTAL_VIEW AS
(
SELECT row_number() OVER ()                                                                   AS ID,
       PROJECTS.NAME                                                                          AS PROJECT,
       USERS.ID                                                                               AS OWNER_ID,
       USERS.USERNAME                                                                         AS OWNER_USERNAME,
       UPSTREAM_JOBS.NAME                                                                     AS UPSTREAM_JOB_NAME,
       PRIORITY_LABELS.VALUE                                                                  AS PRIORITY,
       FEATURE_LABELS.VALUE                                                                   AS FEATURE,
       TASK_ITEMS.JIRA_ID                                                                     AS TASK,
       BUG_ITEMS.JIRA_ID                                                                      AS BUG,
       TEST_CONFIGS.ENV                                                                       as ENV,
       case
           when (TEST_CONFIGS.PLATFORM IS NULL OR TEST_CONFIGS.PLATFORM = '') then 'N/A'
           else TEST_CONFIGS.PLATFORM end                                                     AS PLATFORM,
       TEST_CONFIGS.BROWSER                                                                   AS BROWSER,
       sum(case when TESTS.STATUS = 'PASSED' then 1 else 0 end)                               AS PASSED,
       sum(case when TESTS.STATUS = 'FAILED' AND TESTS.KNOWN_ISSUE = FALSE then 1 else 0 end) AS FAILED,
       sum(case when TESTS.STATUS = 'FAILED' AND TESTS.KNOWN_ISSUE = TRUE then 1 else 0 end)  AS KNOWN_ISSUE,
       sum(case when TESTS.STATUS = 'SKIPPED' then 1 else 0 end)                              AS SKIPPED,
       sum(case when TESTS.STATUS = 'ABORTED' then 1 else 0 end)                              AS ABORTED,
       sum(case when TESTS.STATUS = 'IN_PROGRESS' then 1 else 0 end)                          AS IN_PROGRESS,
       COUNT(*)                                                                               AS TOTAL,
       date_trunc('day', TEST_RUNS.STARTED_AT)                                                AS STARTED_AT,
       sum(EXTRACT(epoch FROM (TESTS.FINISH_TIME - TESTS.START_TIME)))::bigint                as TOTAL_SECONDS,
       case
           when (date_trunc('month', TESTS.START_TIME) = date_trunc('month', current_date)) then
               ROUND(sum(EXTRACT(epoch FROM (TESTS.FINISH_TIME - TESTS.START_TIME))) / extract(day from current_date) *
                     extract(day from date_trunc('day', date_trunc('month', current_date) + interval '1 month') -
                                      interval '1 day'))
           else
               sum(EXTRACT(epoch FROM (TESTS.FINISH_TIME - TESTS.START_TIME)))::bigint
           end                                                                                AS TOTAL_ETA_SECONDS,
       avg(TESTS.FINISH_TIME - TESTS.START_TIME)                                              as AVG_TIME
FROM TESTS
         INNER JOIN
     TEST_RUNS ON TESTS.TEST_RUN_ID = TEST_RUNS.ID
         INNER JOIN
     TEST_CASES ON TESTS.TEST_CASE_ID = TEST_CASES.ID
         INNER JOIN
     USERS ON TEST_CASES.PRIMARY_OWNER_ID = USERS.ID
         LEFT JOIN JOBS UPSTREAM_JOBS ON TEST_RUNS.UPSTREAM_JOB_ID = UPSTREAM_JOBS.ID
         INNER JOIN
     PROJECTS ON TEST_RUNS.PROJECT_ID = PROJECTS.ID
         INNER JOIN
     TEST_CONFIGS ON TEST_RUNS.CONFIG_ID = TEST_CONFIGs.ID
         LEFT JOIN TESTS_LABELS PRIORITY_TEST_LABELS ON TESTS.ID = PRIORITY_TEST_LABELS.TEST_ID AND
                                                        PRIORITY_TEST_LABELS.LABEL_ID IN
                                                        (SELECT ID FROM LABELS WHERE key = 'priority')
         LEFT JOIN LABELS PRIORITY_LABELS
                   ON (PRIORITY_TEST_LABELS.LABEL_ID = PRIORITY_LABELS.ID AND PRIORITY_LABELS.KEY = 'priority')
         LEFT JOIN TESTS_LABELS FEATURE_TEST_LABELS ON TESTS.ID = FEATURE_TEST_LABELS.TEST_ID AND
                                                       FEATURE_TEST_LABELS.LABEL_ID IN (SELECT ID FROM LABELS WHERE key = 'feature')
         LEFT JOIN LABELS FEATURE_LABELS ON FEATURE_TEST_LABELS.LABEL_ID = FEATURE_LABELS.ID AND FEATURE_LABELS.KEY = 'feature'
         LEFT JOIN TEST_WORK_ITEMS TASK_WORK_ITEMS ON TESTS.ID = TASK_WORK_ITEMS.TEST_ID AND
                                                      TASK_WORK_ITEMS.WORK_ITEM_ID IN
                                                      (SELECT ID FROM WORK_ITEMS WHERE type = 'TASK')
         LEFT JOIN WORK_ITEMS TASK_ITEMS ON (TASK_WORK_ITEMS.WORK_ITEM_ID = TASK_ITEMS.ID AND TASK_ITEMS.TYPE = 'TASK')
         LEFT JOIN TEST_WORK_ITEMS BUG_WORK_ITEMS ON TESTS.ID = BUG_WORK_ITEMS.TEST_ID AND
                                                     BUG_WORK_ITEMS.WORK_ITEM_ID IN
                                                     (SELECT ID FROM WORK_ITEMS WHERE type = 'BUG')
         LEFT JOIN WORK_ITEMS BUG_ITEMS ON (BUG_WORK_ITEMS.WORK_ITEM_ID = BUG_ITEMS.ID AND BUG_ITEMS.TYPE = 'BUG')
WHERE TEST_RUNS.STARTED_AT < current_date
GROUP BY PROJECTS.NAME, OWNER_ID, OWNER_USERNAME,
         UPSTREAM_JOB_NAME,
         TEST_CONFIGS.ENV, TEST_CONFIGS.PLATFORM, TEST_CONFIGS.BROWSER,
         date_trunc('month', TESTS.START_TIME), date_trunc('day', TEST_RUNS.STARTED_AT),
         PRIORITY_LABELS.VALUE, FEATURE_LABELS.VALUE,
         TASK_ITEMS.JIRA_ID, BUG_ITEMS.JIRA_ID
    );

DROP INDEX IF EXISTS TOTAL_VIEW_INDEX;
CREATE UNIQUE INDEX TOTAL_VIEW_INDEX ON TOTAL_VIEW (ID);

DROP INDEX IF EXISTS TOTAL_VIEW_PROJECT_INDEX;
CREATE INDEX TOTAL_VIEW_PROJECT_INDEX ON TOTAL_VIEW (PROJECT);

DROP INDEX IF EXISTS TOTAL_VIEW_OWNER_ID_INDEX;
CREATE INDEX TOTAL_VIEW_OWNER_ID_INDEX ON TOTAL_VIEW (OWNER_ID);

DROP INDEX IF EXISTS TOTAL_VIEW_OWNER_INDEX;
CREATE INDEX TOTAL_VIEW_OWNER_INDEX ON TOTAL_VIEW (OWNER_USERNAME);

DROP INDEX IF EXISTS TOTAL_VIEW_UPSTREAM_JOB_NAME_INDEX;
CREATE INDEX TOTAL_VIEW_UPSTREAM_JOB_NAME_INDEX ON TOTAL_VIEW (UPSTREAM_JOB_NAME);

DROP INDEX IF EXISTS TOTAL_VIEW_PRIORITY_INDEX;
CREATE INDEX TOTAL_VIEW_PRIORITY_INDEX ON TOTAL_VIEW (PRIORITY);

DROP INDEX IF EXISTS TOTAL_VIEW_FEATURE_INDEX;
CREATE INDEX TOTAL_VIEW_FEATURE_INDEX ON TOTAL_VIEW (FEATURE);

DROP INDEX IF EXISTS TOTAL_VIEW_TASK_INDEX;
CREATE INDEX TOTAL_VIEW_TASK_INDEX ON TOTAL_VIEW (TASK);

DROP INDEX IF EXISTS TOTAL_VIEW_BUG_INDEX;
CREATE INDEX TOTAL_VIEW_BUG_INDEX ON TOTAL_VIEW (BUG);

DROP INDEX IF EXISTS TOTAL_VIEW_ENV_INDEX;
CREATE INDEX TOTAL_VIEW_ENV_INDEX ON TOTAL_VIEW (ENV);

DROP INDEX IF EXISTS TOTAL_VIEW_PLATFORM_INDEX;
CREATE INDEX TOTAL_VIEW_PLATFORM_INDEX ON TOTAL_VIEW (PLATFORM);

DROP INDEX IF EXISTS TOTAL_VIEW_BROWSER_INDEX;
CREATE INDEX TOTAL_VIEW_BROWSER_INDEX ON TOTAL_VIEW (BROWSER);

DROP INDEX IF EXISTS TOTAL_VIEW_PASSED_INDEX;
CREATE INDEX TOTAL_VIEW_PASSED_INDEX ON TOTAL_VIEW (PASSED);

DROP INDEX IF EXISTS TOTAL_VIEW_FAILED_INDEX;
CREATE INDEX TOTAL_VIEW_FAILED_INDEX ON TOTAL_VIEW (FAILED);

DROP INDEX IF EXISTS TOTAL_VIEW_KNOWN_ISSUE_INDEX;
CREATE INDEX TOTAL_VIEW_KNOWN_ISSUE_INDEX ON TOTAL_VIEW (KNOWN_ISSUE);

DROP INDEX IF EXISTS TOTAL_VIEW_SKIPPED_INDEX;
CREATE INDEX TOTAL_VIEW_SKIPPED_INDEX ON TOTAL_VIEW (SKIPPED);

DROP INDEX IF EXISTS TOTAL_VIEW_ABORTED_INDEX;
CREATE INDEX TOTAL_VIEW_ABORTED_INDEX ON TOTAL_VIEW (ABORTED);

DROP INDEX IF EXISTS TOTAL_VIEW_IN_PROGRESS_INDEX;
CREATE INDEX TOTAL_VIEW_IN_PROGRESS_INDEX ON TOTAL_VIEW (IN_PROGRESS);

DROP INDEX IF EXISTS TOTAL_VIEW_TOTAL_INDEX;
CREATE INDEX TOTAL_VIEW_TOTAL_INDEX ON TOTAL_VIEW (TOTAL);

DROP INDEX IF EXISTS TOTAL_VIEW_STARTED_AT_INDEX;
CREATE INDEX TOTAL_VIEW_STARTED_AT_INDEX ON TOTAL_VIEW (STARTED_AT);

DROP INDEX IF EXISTS TOTAL_VIEW_TOTAL_SECONDS_INDEX;
CREATE INDEX TOTAL_VIEW_TOTAL_SECONDS_INDEX ON TOTAL_VIEW (TOTAL_SECONDS);

DROP INDEX IF EXISTS TOTAL_VIEW_TOTAL_ETA_SECONDS_INDEX;
CREATE INDEX TOTAL_VIEW_TOTAL_ETA_SECONDS_INDEX ON TOTAL_VIEW (TOTAL_ETA_SECONDS);

DROP INDEX IF EXISTS TOTAL_VIEW_AVG_TIME_INDEX;
CREATE INDEX TOTAL_VIEW_AVG_TIME_INDEX ON TOTAL_VIEW (AVG_TIME);

